/*
 * This is an opaque version of the WordMap interface
 *
 *    written by J Dean Brock, Nov 2010
 *
 */

typedef void *WordMap ;

/*
 * Create an empty WordMap.
 * Return a NULL if this operation cannot be performed
 * due to lack of dynamic storage.
 */
WordMap CreateWM (void) ;

/*
 * Insert a new key,value pair into the WordMap.
 * If the key is already in use, update it with the new value.
 * Your program must copy word.  The value is assumed to
 * be a generic pointer (void *).
 * Return a non-zero value if this operation cannot be
 * performed due to lack of dynamic storage.
 */
int     InsertWM(WordMap, const char *key, const void *value) ;

/*
 * Obtain the value (a generic pointer) associate with a key.
 * If the key is not in the map, just return NULL.
 */
void *  LookupWM(WordMap, const char *key) ;

/*
 * Delete all space used by the WordMap key index.
 * Do *not* try to delete the values!
 * Obviously WordMap should not be used after this call.
 */
void    DestroyWM (WordMap) ;
